unit Unit1;

{$mode objfpc}{$H+}

interface

uses
  Classes, SysUtils, FileUtil, Forms, Controls, Graphics, Dialogs, StdCtrls;

type

  { TForm1 }

  TForm1 = class(TForm)
    BtnDecToEsa: TButton;
    BtnEsaToDec: TButton;
    BtnClear: TButton;
    EdtDecimale: TEdit;
    EdtEsadecimale: TEdit;
    Label1: TLabel;
    Label2: TLabel;
    procedure BtnDecToEsaClick(Sender: TObject);
    procedure BtnEsaToDecClick(Sender: TObject);
    procedure BtnClearClick(Sender: TObject);
  private
    { private declarations }
  public
    { public declarations }
  end;

var
  Form1: TForm1;

implementation

{$R *.lfm}

{ TForm1 }

Var Decimale : Integer ; Esadecimale, Cifra : String ;
    i, Pot, Resto : Integer ;    Car : Char ;

procedure TForm1.BtnClearClick(Sender: TObject);
begin
  EdtDecimale.Clear ;  EdtEsadecimale.Clear ;
end;

procedure TForm1.BtnDecToEsaClick(Sender: TObject);
begin
  Decimale := StrToInt(EdtDecimale.Text) ;
  Esadecimale := '' ;
  if Decimale = 0 then Esadecimale := '0' ;
  While Decimale > 0 do
    begin
      Resto := Decimale Mod 16 ;
      Decimale := Decimale Div 16 ;
      Case Resto of
         0 ..  9 : Esadecimale := Chr(48 + Resto) + Esadecimale ;
        10 .. 15 : Esadecimale := Chr(55 + Resto ) + Esadecimale ;   // 55 = 65 - 10
      end;
    end;
  EdtEsadecimale.Text := Esadecimale ;
end;

procedure TForm1.BtnEsaToDecClick(Sender: TObject);
begin
  Pot := 1 ;
  Esadecimale := UpperCase(EdtEsadecimale.Text) ;
  EdtEsadecimale.Text := Esadecimale ;
  Decimale := 0 ;
  for i := length(Esadecimale) downto 1 do
    begin
       Car := Esadecimale[i] ;
       case Car of
         '0' .. '9' : Decimale :=  Decimale + Pot * StrToInt(Car) ;
         'A' .. 'F' : Decimale :=  Decimale + Pot * (Ord(Car) - 55) ;
       end ;
       Pot := Pot * 16 ;
    end;
  EdtDecimale.Text := IntToStr(Decimale) ;
end;

end.

